VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsAppendOp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements clsBaseOp

Private strAppend As String

Private Function clsBaseOp_Init(ByRef strStatement As String) As Boolean
    clsBaseOp_Init = False
    If InStr(strStatement, "Append") <> 1 Then
        strStatement = "Input statement did not start with Append"
        Exit Function
    End If
    strStatement = LTrim(Right(strStatement, Len(strStatement) - 6))
    If Left$(strStatement, 1) <> "(" Then
        strStatement = "Missing ( after Append"
        Exit Function
    End If
    strStatement = LTrim$(Right$(strStatement, Len(strStatement) - 1))
    If Left$(strStatement, 1) <> """" Then
        strStatement = "Missing start of string ("") after start of function arguments"
        Exit Function
    End If
    Dim iStrEnd As Long
    strStatement = Right$(strStatement, Len(strStatement) - 1)
    iStrEnd = InStr(strStatement, """")
    If iStrEnd = 0 Then
        strStatement = "Missing end of string"
        Exit Function
    End If
    Do While Mid$(strStatement, iStrEnd - 1, 1) = "\" 'Escape for " is \"
        iStrEnd = InStr(iStrEnd + 1, strStatement, """")
    Loop
    strAppend = Mid$(strStatement, 1, iStrEnd - 1)
    strStatement = LTrim$(Right$(strStatement, Len(strStatement) - iStrEnd))
    If Left$(strStatement, 1) <> ")" Then
        strStatement = "Missing ) after function argument"
        Exit Function
    End If
    strStatement = Right$(strStatement, Len(strStatement) - 1)
    clsBaseOp_Init = True
End Function

Private Function clsBaseOp_Process(ByRef strIn As String) As Long
    strIn = strIn & strAppend
    clsBaseOp_Process = 1
End Function
