VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "FLSM"
   ClientHeight    =   4860
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   7440
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4860
   ScaleWidth      =   7440
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtLog 
      Height          =   2055
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   6
      Top             =   2640
      Width           =   7215
   End
   Begin VB.CommandButton btnStart 
      Caption         =   "Process save files"
      Height          =   375
      Left            =   4920
      TabIndex        =   5
      Top             =   720
      Width           =   2415
   End
   Begin VB.CommandButton btnChooseOp 
      Caption         =   "Choose new operation file"
      Height          =   375
      Left            =   2280
      TabIndex        =   4
      Top             =   720
      Width           =   2415
   End
   Begin VB.CommandButton btnChooseDir 
      Caption         =   "Choose new directory"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   720
      Width           =   1935
   End
   Begin VB.TextBox txtOperationFile 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      BorderStyle     =   0  'None
      Height          =   495
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   1  'Horizontal
      TabIndex        =   2
      ToolTipText     =   "The currently selected operation file"
      Top             =   1920
      Width           =   7215
   End
   Begin VB.TextBox txtPath 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      BorderStyle     =   0  'None
      Height          =   495
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   1  'Horizontal
      TabIndex        =   1
      ToolTipText     =   "The currently selected directory"
      Top             =   1320
      Width           =   7215
   End
   Begin VB.Label lblTitle 
      Alignment       =   2  'Center
      Caption         =   "Freelancer Save Manipulator"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   7215
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Folder stuff
Private Const CSIDL_PERSONAL = &H5                'My Documents

Private Sub btnChooseDir_Click()
    Dim strDir As String
    strDir = GetFolder(Me.hWnd, "Choose directory to search for save files in")
    If LenB(strDir) <> 0 Then
        txtPath.Text = strDir
    End If
End Sub

Private Sub btnChooseOp_Click()
    Dim strFile As String
    strFile = GetOpenFileName(Me.hWnd, vbNullString, "FLSM Scripts (*.flm)" & Chr(0) & "*.flm" & Chr(0) & "All Files" & Chr(0) & "*.*" & String(2, 0), "Select operation script file...")
    If LenB(strFile) <> 0 Then
        txtOperationFile.Text = strFile
    End If
End Sub

Private Sub btnStart_Click()
    If LenB(txtOperationFile.Text) = 0 Then
        addLog "Error: script operation file does not exist"
        Exit Sub
    End If
    If LenB(Dir(txtOperationFile.Text)) = 0 Then
        addLog "Error: script operation file does not exist"
        Exit Sub
    End If
    If LenB(txtPath.Text) = 0 Then
        addLog "Error: script operation file does not exist"
        Exit Sub
    End If
    If LenB(Dir(txtPath.Text, vbDirectory)) = 0 Then
        addLog "Error: Directory to search for files in does not exist"
        Exit Sub
    End If
    
    'Parse script
    addLog "Parsing script..."
    Dim objScripts() As clsBaseOp
    If Not parseScript(txtOperationFile.Text, objScripts) Then
        Exit Sub 'error occured
    End If
    
    'Get all files to apply script to
    Dim subFolders As Variant
    txtLog.Text = "Looking for subfolders in " & txtPath.Text
    subFolders = getSubFolders(txtPath.Text)
    ReDim Preserve subFolders(LBound(subFolders) To UBound(subFolders) + 1)
    subFolders(UBound(subFolders)) = txtPath.Text
    Dim allFiles As New Collection
    Dim i As Integer
    For i = LBound(subFolders) To UBound(subFolders)
        addLog "Looking for character files in " & subFolders(i)
        DoEvents
        Dim charPath As String
        charPath = Dir(subFolders(i) & "\*.fl", vbReadOnly)
        Do While LenB(charPath) <> 0
            allFiles.Add (subFolders(i) & "\" & charPath)
            charPath = Dir
        Loop
    Next i
    
    'Process files
    Dim iNumFiles As Long, iNumProcessed As Long
    iNumFiles = allFiles.Count
    iNumProcessed = 0
    addLog "Found " & iNumFiles & " character files, processing them now...00.00%"
    Dim strFilename As Variant
    For Each strFilename In allFiles
        Dim strFile As String
        Dim bEncoded As Boolean
        bEncoded = FLCDecode(CStr(strFilename), strFile)
        For i = LBound(objScripts) To UBound(objScripts) - 1
            Call objScripts(i).Process(strFile)
        Next i
        If bEncoded Then
            Call FLCEncode(strFile, CStr(strFilename))
        Else
            writeFile strFile, CStr(strFilename)
        End If
        iNumProcessed = iNumProcessed + 1
        replaceLog Format(iNumProcessed / iNumFiles, "##00.00%"), 6
        DoEvents
    Next strFilename
    For i = LBound(objScripts) To UBound(objScripts) - 1
        Set objScripts(i) = Nothing
    Next i
    Set allFiles = Nothing
    
    addLog "Processed character files successfully"
End Sub

Private Sub Form_Load()
    txtPath.Text = GetSpecialFolderLocation(CSIDL_PERSONAL) & "\My Games\Freelancer\Accts\MultiPlayer"
    If LenB(Dir(txtPath.Text, vbDirectory)) = 0 Then txtPath.Text = ""
End Sub

Private Sub txtLog_Change()
    txtLog.SelStart = Len(txtLog.Text)
    txtLog.SelLength = 0
End Sub
