Attribute VB_Name = "mBrowseForFile"
Option Explicit

Public Type OPENFILENAME
        lStructSize As Long '=608
        hwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type

Private Declare Function GetOpenFileNameA Lib "comdlg32.dll" (lpofn As OPENFILENAME) As Long
Private Declare Function CommDlgExtendedError Lib "comdlg32.dll" () As Long

Public Function GetOpenFileName(lhWnd As Long, strStartDir As String, strFileFilters As String, strDialogTitle As String) As String
    Dim ofn As OPENFILENAME
    Dim strFile As String * 512
    strFile = Chr(0)
    With ofn
        .lStructSize = 76
        .hwndOwner = lhWnd
        .hInstance = 0
        .lpstrFilter = strFileFilters
        .lpstrCustomFilter = vbNullString
        .nMaxCustFilter = 0
        .nFilterIndex = 0
        .lpstrFile = strFile
        .nMaxFile = 512
        .lpstrFileTitle = vbNullString
        .nMaxFileTitle = 0
        .lpstrInitialDir = strStartDir
        .lpstrTitle = strDialogTitle
        .nFileOffset = 0
        .nFileExtension = 0
        .lpstrDefExt = vbNullString
        .lCustData = 0
        .lpfnHook = 0
        .lpTemplateName = 0
    End With
    If GetOpenFileNameA(ofn) = 0 Then
        GetOpenFileName = ""
        Exit Function
    End If
    GetOpenFileName = ofn.lpstrFile
End Function
