Attribute VB_Name = "mScript"
Option Explicit

'Function names
Private Const APPEND As String = "Append"

Public Function parseScript(strFilename As String, objRet() As clsBaseOp) As Boolean
    parseScript = False
    'On Error GoTo errHandler
    Dim strScript As String
    Dim iFileNo As Integer
    iFileNo = FreeFile()
    Open strFilename For Input As #iFileNo
    strScript = Input$(LOF(iFileNo), iFileNo)
    Close #1
    strScript = LTrim$(strScript)
    
    ReDim objRet(0 To 0)
    Do While LenB(strScript) <> 0
        If Left$(strScript, Len(APPEND)) = APPEND Then
            Dim objAppend As clsBaseOp
            Set objAppend = New clsAppendOp
            If Not objAppend.Init(strScript) Then
                addLog "Error while parsing script file " & strFilename & ": " & strScript
                Exit Function
            End If
            Set objRet(UBound(objRet)) = objAppend
            ReDim Preserve objRet(0 To UBound(objRet) + 1)
        Else
            addLog "Error while parsing script file " & strFilename & ": unexpected token at start of line"
            Exit Function
        End If
        'Find next statement
        Dim iEndStatement As Long
        iEndStatement = InStr(strScript, ";")
        If iEndStatement = 0 Then
            addLog "Error while parsing script file " & strFilename & ": could not find end of statement"
            Exit Function
        End If
        Dim iNextLine As Long
        iNextLine = InStr(iEndStatement, strScript, vbCrLf)
        If iNextLine = 0 Then
            parseScript = True
            Exit Function
        End If
        strScript = LTrim$(Right$(strScript, Len(strScript) - iNextLine - 1))
    Loop
    parseScript = True
    Exit Function
    
errHandler:
    addLog "Error while parsing script file " & strFilename & ": " & Err.Description & " thrown by " & Err.Source
End Function

